Index: IMGUI/imgui.cpp
===================================================================
--- IMGUI/imgui.cpp	(revision c58ebc3899e898504313cf42b9c1c05170b13f8f)
+++ IMGUI/imgui.cpp	(revision e66fd66b98dfb2d3f0f1af0833f4b2957f60d166)
@@ -1261,128 +1645,115 @@
 static inline int ImTextCharToUtf8(char* buf, int buf_size, unsigned int c)
 {
-   if (c < 0x80)
-   {
-      buf[0] = (char)c;
-      return 1;
-   }
-   if (c < 0x800)
-   {
-      if (buf_size < 2) return 0;
-      buf[0] = (char)(0xc0 + (c >> 6));
-      buf[1] = (char)(0x80 + (c & 0x3f));
-      return 2;
-   }
-   if (c >= 0xdc00 && c < 0xe000)
-   {
-      return 0;
-   }
-   if (c >= 0xd800 && c < 0xdc00)
-   {
-      if (buf_size < 4) return 0;
-      buf[0] = (char)(0xf0 + (c >> 18));
-      buf[1] = (char)(0x80 + ((c >> 12) & 0x3f));
-      buf[2] = (char)(0x80 + ((c >> 6) & 0x3f));
-      buf[3] = (char)(0x80 + ((c) & 0x3f));
-      return 4;
-   }
-   //else if (c < 0x10000)
-   {
-      if (buf_size < 3) return 0;
-      buf[0] = (char)(0xe0 + (c >> 12));
-      buf[1] = (char)(0x80 + ((c >> 6) & 0x3f));
-      buf[2] = (char)(0x80 + ((c) & 0x3f));
-      return 3;
-   }
+    if (c < 0x80)
+    {
+        buf[0] = (char)c;
+        return 1;
+    }
+    if (c < 0x800)
+    {
+        if (buf_size < 2) return 0;
+        buf[0] = (char)(0xc0 + (c >> 6));
+        buf[1] = (char)(0x80 + (c & 0x3f));
+        return 2;
+    }
+    if (c < 0x10000)
+    {
+        if (buf_size < 3) return 0;
+        buf[0] = (char)(0xe0 + (c >> 12));
+        buf[1] = (char)(0x80 + ((c >> 6) & 0x3f));
+        buf[2] = (char)(0x80 + ((c ) & 0x3f));
+        return 3;
+    }
+    if (c <= 0x10FFFF)
+    {
+        if (buf_size < 4) return 0;
+        buf[0] = (char)(0xf0 + (c >> 18));
+        buf[1] = (char)(0x80 + ((c >> 12) & 0x3f));
+        buf[2] = (char)(0x80 + ((c >> 6) & 0x3f));
+        buf[3] = (char)(0x80 + ((c ) & 0x3f));
+        return 4;
+    }
+    // Invalid code point, the max unicode is 0x10FFFF
+    return 0;
+}
+
+// Not optimal but we very rarely use this function.
+int ImTextCountUtf8BytesFromChar(const char* in_text, const char* in_text_end)
+{
+    unsigned int unused = 0;
+    return ImTextCharFromUtf8(&unused, in_text, in_text_end);
 }
 
 static inline int ImTextCountUtf8BytesFromChar(unsigned int c)
 {
-   if (c < 0x80) return 1;
-   if (c < 0x800) return 2;
-   if (c >= 0xdc00 && c < 0xe000) return 0;
-   if (c >= 0xd800 && c < 0xdc00) return 4;
-   return 3;
+    if (c < 0x80) return 1;
+    if (c < 0x800) return 2;
+    if (c < 0x10000) return 3;
+    if (c <= 0x10FFFF) return 4;
+    return 3;
 }
 
 int ImTextStrToUtf8(char* buf, int buf_size, const ImWchar* in_text, const ImWchar* in_text_end)
 {
-   char* buf_out = buf;
-   const char* buf_end = buf + buf_size;
-   while (buf_out < buf_end - 1 && (!in_text_end || in_text < in_text_end) && *in_text)
-   {
-      unsigned int c = (unsigned int)(*in_text++);
-      if (c < 0x80)
-         *buf_out++ = (char)c;
-      else
-         buf_out += ImTextCharToUtf8(buf_out, (int)(buf_end - buf_out - 1), c);
-   }
-   *buf_out = 0;
-   return (int)(buf_out - buf);
+    char* buf_out = buf;
+    const char* buf_end = buf + buf_size;
+    while (buf_out < buf_end - 1 && (!in_text_end || in_text < in_text_end) && *in_text)
+    {
+        unsigned int c = (unsigned int)(*in_text++);
+        if (c < 0x80)
+            *buf_out++ = (char)c;
+        else
+            buf_out += ImTextCharToUtf8(buf_out, (int)(buf_end - buf_out - 1), c);
+    }
+    *buf_out = 0;
+    return (int)(buf_out - buf);
 }
 
 int ImTextCountUtf8BytesFromStr(const ImWchar* in_text, const ImWchar* in_text_end)
 {
-   int bytes_count = 0;
-   while ((!in_text_end || in_text < in_text_end) && *in_text)
-   {
-      unsigned int c = (unsigned int)(*in_text++);
-      if (c < 0x80)
-         bytes_count++;
-      else
-         bytes_count += ImTextCountUtf8BytesFromChar(c);
-   }
-   return bytes_count;
+    int bytes_count = 0;
+    while ((!in_text_end || in_text < in_text_end) && *in_text)
+    {
+        unsigned int c = (unsigned int)(*in_text++);
+        if (c < 0x80)
+            bytes_count++;
+        else
+            bytes_count += ImTextCountUtf8BytesFromChar(c);
+    }
+    return bytes_count;
+}
+
+//-----------------------------------------------------------------------------
+// [SECTION] MISC HELPERS/UTILITIES (Color functions)
+// Note: The Convert functions are early design which are not consistent with other API.
+//-----------------------------------------------------------------------------
+
+IMGUI_API ImU32 ImAlphaBlendColors(ImU32 col_a, ImU32 col_b)
+{
+    float t = ((col_b >> IM_COL32_A_SHIFT) & 0xFF) / 255.f;
+    int r = ImLerp((int)(col_a >> IM_COL32_R_SHIFT) & 0xFF, (int)(col_b >> IM_COL32_R_SHIFT) & 0xFF, t);
+    int g = ImLerp((int)(col_a >> IM_COL32_G_SHIFT) & 0xFF, (int)(col_b >> IM_COL32_G_SHIFT) & 0xFF, t);
+    int b = ImLerp((int)(col_a >> IM_COL32_B_SHIFT) & 0xFF, (int)(col_b >> IM_COL32_B_SHIFT) & 0xFF, t);
+    return IM_COL32(r, g, b, 0xFF);
 }
 
 ImVec4 ImGui::ColorConvertU32ToFloat4(ImU32 in)
 {
-   float s = 1.0f / 255.0f;
-   return ImVec4(
-      ((in >> IM_COL32_R_SHIFT) & 0xFF) * s,
-      ((in >> IM_COL32_G_SHIFT) & 0xFF) * s,
-      ((in >> IM_COL32_B_SHIFT) & 0xFF) * s,
-      ((in >> IM_COL32_A_SHIFT) & 0xFF) * s);
+    float s = 1.0f / 255.0f;
+    return ImVec4(
+        ((in >> IM_COL32_R_SHIFT) & 0xFF) * s,
+        ((in >> IM_COL32_G_SHIFT) & 0xFF) * s,
+        ((in >> IM_COL32_B_SHIFT) & 0xFF) * s,
+        ((in >> IM_COL32_A_SHIFT) & 0xFF) * s);
 }
 
 ImU32 ImGui::ColorConvertFloat4ToU32(const ImVec4& in)
 {
-   ImU32 out;
-   out = ((ImU32)IM_F32_TO_INT8_SAT(in.x)) << IM_COL32_R_SHIFT;
-   out |= ((ImU32)IM_F32_TO_INT8_SAT(in.y)) << IM_COL32_G_SHIFT;
-   out |= ((ImU32)IM_F32_TO_INT8_SAT(in.z)) << IM_COL32_B_SHIFT;
-   out |= ((ImU32)IM_F32_TO_INT8_SAT(in.w)) << IM_COL32_A_SHIFT;
-   return out;
-}
-
-ImU32 ImGui::GetColorU32(ImGuiCol idx, float alpha_mul)
-{
-   ImGuiStyle& style = GImGui->Style;
-   ImVec4 c = style.Colors[idx];
-   c.w *= style.Alpha * alpha_mul;
-   return ColorConvertFloat4ToU32(c);
-}
-
-ImU32 ImGui::GetColorU32(const ImVec4& col)
-{
-   ImGuiStyle& style = GImGui->Style;
-   ImVec4 c = col;
-   c.w *= style.Alpha;
-   return ColorConvertFloat4ToU32(c);
-}
-
-const ImVec4& ImGui::GetStyleColorVec4(ImGuiCol idx)
-{
-   ImGuiStyle& style = GImGui->Style;
-   return style.Colors[idx];
-}
-
-ImU32 ImGui::GetColorU32(ImU32 col)
-{
-   float style_alpha = GImGui->Style.Alpha;
-   if (style_alpha >= 1.0f)
-      return col;
-   ImU32 a = (col & IM_COL32_A_MASK) >> IM_COL32_A_SHIFT;
-   a = (ImU32)(a * style_alpha); // We don't need to clamp 0..255 because Style.Alpha is in 0..1 range.
-   return (col & ~IM_COL32_A_MASK) | (a << IM_COL32_A_SHIFT);
+    ImU32 out;
+    out  = ((ImU32)IM_F32_TO_INT8_SAT(in.x)) << IM_COL32_R_SHIFT;
+    out |= ((ImU32)IM_F32_TO_INT8_SAT(in.y)) << IM_COL32_G_SHIFT;
+    out |= ((ImU32)IM_F32_TO_INT8_SAT(in.z)) << IM_COL32_B_SHIFT;
+    out |= ((ImU32)IM_F32_TO_INT8_SAT(in.w)) << IM_COL32_A_SHIFT;
+    return out;
 }
 
@@ -1391,20 +1762,20 @@
 void ImGui::ColorConvertRGBtoHSV(float r, float g, float b, float& out_h, float& out_s, float& out_v)
 {
-   float K = 0.f;
-   if (g < b)
-   {
-      ImSwap(g, b);
-      K = -1.f;
-   }
-   if (r < g)
-   {
-      ImSwap(r, g);
-      K = -2.f / 6.f - K;
-   }
-
-   const float chroma = r - (g < b ? g : b);
-   out_h = fabsf(K + (g - b) / (6.f * chroma + 1e-20f));
-   out_s = chroma / (r + 1e-20f);
-   out_v = r;
+    float K = 0.f;
+    if (g < b)
+    {
+        ImSwap(g, b);
+        K = -1.f;
+    }
+    if (r < g)
+    {
+        ImSwap(r, g);
+        K = -2.f / 6.f - K;
+    }
+
+    const float chroma = r - (g < b ? g : b);
+    out_h = ImFabs(K + (g - b) / (6.f * chroma + 1e-20f));
+    out_s = chroma / (r + 1e-20f);
+    out_v = r;
 }
 
@@ -1413,113 +1784,55 @@
 void ImGui::ColorConvertHSVtoRGB(float h, float s, float v, float& out_r, float& out_g, float& out_b)
 {
-   if (s == 0.0f)
-   {
-      // gray
-      out_r = out_g = out_b = v;
-      return;
-   }
-
-   h = fmodf(h, 1.0f) / (60.0f / 360.0f);
-   int   i = (int)h;
-   float f = h - (float)i;
-   float p = v * (1.0f - s);
-   float q = v * (1.0f - s * f);
-   float t = v * (1.0f - s * (1.0f - f));
-
-   switch (i)
-   {
-   case 0: out_r = v; out_g = t; out_b = p; break;
-   case 1: out_r = q; out_g = v; out_b = p; break;
-   case 2: out_r = p; out_g = v; out_b = t; break;
-   case 3: out_r = p; out_g = q; out_b = v; break;
-   case 4: out_r = t; out_g = p; out_b = v; break;
-   case 5: default: out_r = v; out_g = p; out_b = q; break;
-   }
-}
-
-FILE* ImFileOpen(const char* filename, const char* mode)
-{
-#if defined(_WIN32) && !defined(__CYGWIN__)
-   // We need a fopen() wrapper because MSVC/Windows fopen doesn't handle UTF-8 filenames. Converting both strings from UTF-8 to wchar format (using a single allocation, because we can)
-   const int filename_wsize = ImTextCountCharsFromUtf8(filename, NULL) + 1;
-   const int mode_wsize = ImTextCountCharsFromUtf8(mode, NULL) + 1;
-   ImVector<ImWchar> buf;
-   buf.resize(filename_wsize + mode_wsize);
-   ImTextStrFromUtf8(&buf[0], filename_wsize, filename, NULL);
-   ImTextStrFromUtf8(&buf[filename_wsize], mode_wsize, mode, NULL);
-   return _wfopen((wchar_t*)&buf[0], (wchar_t*)&buf[filename_wsize]);
-#else
-   return fopen(filename, mode);
-#endif
-}
-
-// Load file content into memory
-// Memory allocated with ImGui::MemAlloc(), must be freed by user using ImGui::MemFree()
-void* ImFileLoadToMemory(const char* filename, const char* file_open_mode, int* out_file_size, int padding_bytes)
-{
-   IM_ASSERT(filename && file_open_mode);
-   if (out_file_size)
-      *out_file_size = 0;
-
-   FILE* f;
-   if ((f = ImFileOpen(filename, file_open_mode)) == NULL)
-      return NULL;
-
-   long file_size_signed;
-   if (fseek(f, 0, SEEK_END) || (file_size_signed = ftell(f)) == -1 || fseek(f, 0, SEEK_SET))
-   {
-      fclose(f);
-      return NULL;
-   }
-
-   int file_size = (int)file_size_signed;
-   void* file_data = ImGui::MemAlloc((size_t)(file_size + padding_bytes));
-   if (file_data == NULL)
-   {
-      fclose(f);
-      return NULL;
-   }
-   if (fread(file_data, 1, (size_t)file_size, f) != (size_t)file_size)
-   {
-      fclose(f);
-      ImGui::MemFree(file_data);
-      return NULL;
-   }
-   if (padding_bytes > 0)
-      memset((void *)(((char*)file_data) + file_size), 0, (size_t)padding_bytes);
-
-   fclose(f);
-   if (out_file_size)
-      *out_file_size = file_size;
-
-   return file_data;
+    if (s == 0.0f)
+    {
+        // gray
+        out_r = out_g = out_b = v;
+        return;
+    }
+
+    h = ImFmod(h, 1.0f) / (60.0f / 360.0f);
+    int   i = (int)h;
+    float f = h - (float)i;
+    float p = v * (1.0f - s);
+    float q = v * (1.0f - s * f);
+    float t = v * (1.0f - s * (1.0f - f));
+
+    switch (i)
+    {
+    case 0: out_r = v; out_g = t; out_b = p; break;
+    case 1: out_r = q; out_g = v; out_b = p; break;
+    case 2: out_r = p; out_g = v; out_b = t; break;
+    case 3: out_r = p; out_g = q; out_b = v; break;
+    case 4: out_r = t; out_g = p; out_b = v; break;
+    case 5: default: out_r = v; out_g = p; out_b = q; break;
+    }
 }
 
 //-----------------------------------------------------------------------------
-// ImGuiStorage
+// [SECTION] ImGuiStorage
 // Helper: Key->value storage
 //-----------------------------------------------------------------------------
 
 // std::lower_bound but without the bullshit
-static ImVector<ImGuiStorage::Pair>::iterator LowerBound(ImVector<ImGuiStorage::Pair>& data, ImGuiID key)
-{
-   ImVector<ImGuiStorage::Pair>::iterator first = data.begin();
-   ImVector<ImGuiStorage::Pair>::iterator last = data.end();
-   size_t count = (size_t)(last - first);
-   while (count > 0)
-   {
-      size_t count2 = count >> 1;
-      ImVector<ImGuiStorage::Pair>::iterator mid = first + count2;
-      if (mid->key < key)
-      {
-         first = ++mid;
-         count -= count2 + 1;
-      }
-      else
-      {
-         count = count2;
-      }
-   }
-   return first;
+static ImGuiStorage::ImGuiStoragePair* LowerBound(ImVector<ImGuiStorage::ImGuiStoragePair>& data, ImGuiID key)
+{
+    ImGuiStorage::ImGuiStoragePair* first = data.Data;
+    ImGuiStorage::ImGuiStoragePair* last = data.Data + data.Size;
+    size_t count = (size_t)(last - first);
+    while (count > 0)
+    {
+        size_t count2 = count >> 1;
+        ImGuiStorage::ImGuiStoragePair* mid = first + count2;
+        if (mid->key < key)
+        {
+            first = ++mid;
+            count -= count2 + 1;
+        }
+        else
+        {
+            count = count2;
+        }
+    }
+    return first;
 }
 
@@ -1527,45 +1840,45 @@
 void ImGuiStorage::BuildSortByKey()
 {
-   struct StaticFunc
-   {
-      static int IMGUI_CDECL PairCompareByID(const void* lhs, const void* rhs)
-      {
-         // We can't just do a subtraction because qsort uses signed integers and subtracting our ID doesn't play well with that.
-         if (((const Pair*)lhs)->key > ((const Pair*)rhs)->key) return +1;
-         if (((const Pair*)lhs)->key < ((const Pair*)rhs)->key) return -1;
-         return 0;
-      }
-   };
-   if (Data.Size > 1)
-      qsort(Data.Data, (size_t)Data.Size, sizeof(Pair), StaticFunc::PairCompareByID);
+    struct StaticFunc
+    {
+        static int IMGUI_CDECL PairCompareByID(const void* lhs, const void* rhs)
+        {
+            // We can't just do a subtraction because qsort uses signed integers and subtracting our ID doesn't play well with that.
+            if (((const ImGuiStoragePair*)lhs)->key > ((const ImGuiStoragePair*)rhs)->key) return +1;
+            if (((const ImGuiStoragePair*)lhs)->key < ((const ImGuiStoragePair*)rhs)->key) return -1;
+            return 0;
+        }
+    };
+    if (Data.Size > 1)
+        ImQsort(Data.Data, (size_t)Data.Size, sizeof(ImGuiStoragePair), StaticFunc::PairCompareByID);
 }
 
 int ImGuiStorage::GetInt(ImGuiID key, int default_val) const
 {
-   ImVector<Pair>::iterator it = LowerBound(const_cast<ImVector<ImGuiStorage::Pair>&>(Data), key);
-   if (it == Data.end() || it->key != key)
-      return default_val;
-   return it->val_i;
+    ImGuiStoragePair* it = LowerBound(const_cast<ImVector<ImGuiStoragePair>&>(Data), key);
+    if (it == Data.end() || it->key != key)
+        return default_val;
+    return it->val_i;
 }
 
 bool ImGuiStorage::GetBool(ImGuiID key, bool default_val) const
 {
-   return GetInt(key, default_val ? 1 : 0) != 0;
+    return GetInt(key, default_val ? 1 : 0) != 0;
 }
 
 float ImGuiStorage::GetFloat(ImGuiID key, float default_val) const
 {
-   ImVector<Pair>::iterator it = LowerBound(const_cast<ImVector<ImGuiStorage::Pair>&>(Data), key);
-   if (it == Data.end() || it->key != key)
-      return default_val;
-   return it->val_f;
+    ImGuiStoragePair* it = LowerBound(const_cast<ImVector<ImGuiStoragePair>&>(Data), key);
+    if (it == Data.end() || it->key != key)
+        return default_val;
+    return it->val_f;
 }
 
 void* ImGuiStorage::GetVoidPtr(ImGuiID key) const
 {
-   ImVector<Pair>::iterator it = LowerBound(const_cast<ImVector<ImGuiStorage::Pair>&>(Data), key);
-   if (it == Data.end() || it->key != key)
-      return NULL;
-   return it->val_p;
+    ImGuiStoragePair* it = LowerBound(const_cast<ImVector<ImGuiStoragePair>&>(Data), key);
+    if (it == Data.end() || it->key != key)
+        return NULL;
+    return it->val_p;
 }
 
@@ -1573,29 +1886,29 @@
 int* ImGuiStorage::GetIntRef(ImGuiID key, int default_val)
 {
-   ImVector<Pair>::iterator it = LowerBound(Data, key);
-   if (it == Data.end() || it->key != key)
-      it = Data.insert(it, Pair(key, default_val));
-   return &it->val_i;
+    ImGuiStoragePair* it = LowerBound(Data, key);
+    if (it == Data.end() || it->key != key)
+        it = Data.insert(it, ImGuiStoragePair(key, default_val));
+    return &it->val_i;
 }
 
 bool* ImGuiStorage::GetBoolRef(ImGuiID key, bool default_val)
 {
-   return (bool*)GetIntRef(key, default_val ? 1 : 0);
+    return (bool*)GetIntRef(key, default_val ? 1 : 0);
 }
 
 float* ImGuiStorage::GetFloatRef(ImGuiID key, float default_val)
 {
-   ImVector<Pair>::iterator it = LowerBound(Data, key);
-   if (it == Data.end() || it->key != key)
-      it = Data.insert(it, Pair(key, default_val));
-   return &it->val_f;
+    ImGuiStoragePair* it = LowerBound(Data, key);
+    if (it == Data.end() || it->key != key)
+        it = Data.insert(it, ImGuiStoragePair(key, default_val));
+    return &it->val_f;
 }
 
 void** ImGuiStorage::GetVoidPtrRef(ImGuiID key, void* default_val)
 {
-   ImVector<Pair>::iterator it = LowerBound(Data, key);
-   if (it == Data.end() || it->key != key)
-      it = Data.insert(it, Pair(key, default_val));
-   return &it->val_p;
+    ImGuiStoragePair* it = LowerBound(Data, key);
+    if (it == Data.end() || it->key != key)
+        it = Data.insert(it, ImGuiStoragePair(key, default_val));
+    return &it->val_p;
 }
 
@@ -1603,48 +1916,48 @@
 void ImGuiStorage::SetInt(ImGuiID key, int val)
 {
-   ImVector<Pair>::iterator it = LowerBound(Data, key);
-   if (it == Data.end() || it->key != key)
-   {
-      Data.insert(it, Pair(key, val));
-      return;
-   }
-   it->val_i = val;
+    ImGuiStoragePair* it = LowerBound(Data, key);
+    if (it == Data.end() || it->key != key)
+    {
+        Data.insert(it, ImGuiStoragePair(key, val));
+        return;
+    }
+    it->val_i = val;
 }
 
 void ImGuiStorage::SetBool(ImGuiID key, bool val)
 {
-   SetInt(key, val ? 1 : 0);
+    SetInt(key, val ? 1 : 0);
 }
 
 void ImGuiStorage::SetFloat(ImGuiID key, float val)
 {
-   ImVector<Pair>::iterator it = LowerBound(Data, key);
-   if (it == Data.end() || it->key != key)
-   {
-      Data.insert(it, Pair(key, val));
-      return;
-   }
-   it->val_f = val;
+    ImGuiStoragePair* it = LowerBound(Data, key);
+    if (it == Data.end() || it->key != key)
+    {
+        Data.insert(it, ImGuiStoragePair(key, val));
+        return;
+    }
+    it->val_f = val;
 }
 
 void ImGuiStorage::SetVoidPtr(ImGuiID key, void* val)
 {
-   ImVector<Pair>::iterator it = LowerBound(Data, key);
-   if (it == Data.end() || it->key != key)
-   {
-      Data.insert(it, Pair(key, val));
-      return;
-   }
-   it->val_p = val;
+    ImGuiStoragePair* it = LowerBound(Data, key);
+    if (it == Data.end() || it->key != key)
+    {
+        Data.insert(it, ImGuiStoragePair(key, val));
+        return;
+    }
+    it->val_p = val;
 }
 
 void ImGuiStorage::SetAllInt(int v)
 {
-   for (int i = 0; i < Data.Size; i++)
-      Data[i].val_i = v;
+    for (int i = 0; i < Data.Size; i++)
+        Data[i].val_i = v;
 }
 
 //-----------------------------------------------------------------------------
-// ImGuiTextFilter
+// [SECTION] ImGuiTextFilter
 //-----------------------------------------------------------------------------
 
@@ -1652,99 +1965,101 @@
 ImGuiTextFilter::ImGuiTextFilter(const char* default_filter)
 {
-   if (default_filter)
-   {
-      ImStrncpy(InputBuf, default_filter, IM_ARRAYSIZE(InputBuf));
-      Build();
-   }
-   else
-   {
-      InputBuf[0] = 0;
-      CountGrep = 0;
-   }
+    if (default_filter)
+    {
+        ImStrncpy(InputBuf, default_filter, IM_ARRAYSIZE(InputBuf));
+        Build();
+    }
+    else
+    {
+        InputBuf[0] = 0;
+        CountGrep = 0;
+    }
 }
 
 bool ImGuiTextFilter::Draw(const char* label, float width)
 {
-   if (width != 0.0f)
-      ImGui::PushItemWidth(width);
-   bool value_changed = ImGui::InputText(label, InputBuf, IM_ARRAYSIZE(InputBuf));
-   if (width != 0.0f)
-      ImGui::PopItemWidth();
-   if (value_changed)
-      Build();
-   return value_changed;
-}
-
-void ImGuiTextFilter::TextRange::split(char separator, ImVector<TextRange>& out)
-{
-   out.resize(0);
-   const char* wb = b;
-   const char* we = wb;
-   while (we < e)
-   {
-      if (*we == separator)
-      {
-         out.push_back(TextRange(wb, we));
-         wb = we + 1;
-      }
-      we++;
-   }
-   if (wb != we)
-      out.push_back(TextRange(wb, we));
+    if (width != 0.0f)
+        ImGui::SetNextItemWidth(width);
+    bool value_changed = ImGui::InputText(label, InputBuf, IM_ARRAYSIZE(InputBuf));
+    if (value_changed)
+        Build();
+    return value_changed;
+}
+
+void ImGuiTextFilter::ImGuiTextRange::split(char separator, ImVector<ImGuiTextRange>* out) const
+{
+    out->resize(0);
+    const char* wb = b;
+    const char* we = wb;
+    while (we < e)
+    {
+        if (*we == separator)
+        {
+            out->push_back(ImGuiTextRange(wb, we));
+            wb = we + 1;
+        }
+        we++;
+    }
+    if (wb != we)
+        out->push_back(ImGuiTextRange(wb, we));
 }
 
 void ImGuiTextFilter::Build()
 {
-   Filters.resize(0);
-   TextRange input_range(InputBuf, InputBuf + strlen(InputBuf));
-   input_range.split(',', Filters);
-
-   CountGrep = 0;
-   for (int i = 0; i != Filters.Size; i++)
-   {
-      Filters[i].trim_blanks();
-      if (Filters[i].empty())
-         continue;
-      if (Filters[i].front() != '-')
-         CountGrep += 1;
-   }
+    Filters.resize(0);
+    ImGuiTextRange input_range(InputBuf, InputBuf + strlen(InputBuf));
+    input_range.split(',', &Filters);
+
+    CountGrep = 0;
+    for (int i = 0; i != Filters.Size; i++)
+    {
+        ImGuiTextRange& f = Filters[i];
+        while (f.b < f.e && ImCharIsBlankA(f.b[0]))
+            f.b++;
+        while (f.e > f.b && ImCharIsBlankA(f.e[-1]))
+            f.e--;
+        if (f.empty())
+            continue;
+        if (Filters[i].b[0] != '-')
+            CountGrep += 1;
+    }
 }
 
 bool ImGuiTextFilter::PassFilter(const char* text, const char* text_end) const
 {
-   if (Filters.empty())
-      return true;
-
-   if (text == NULL)
-      text = "";
-
-   for (int i = 0; i != Filters.Size; i++)
-   {
-      const TextRange& f = Filters[i];
-      if (f.empty())
-         continue;
-      if (f.front() == '-')
-      {
-         // Subtract
-         if (ImStristr(text, text_end, f.begin() + 1, f.end()) != NULL)
-            return false;
-      }
-      else
-      {
-         // Grep
-         if (ImStristr(text, text_end, f.begin(), f.end()) != NULL)
-            return true;
-      }
-   }
-
-   // Implicit * grep
-   if (CountGrep == 0)
-      return true;
-
-   return false;
+    if (Filters.empty())
+        return true;
+
+    if (text == NULL)
+        text = "";
+
+    for (int i = 0; i != Filters.Size; i++)
+    {
+        const ImGuiTextRange& f = Filters[i];
+        if (f.empty())
+            continue;
+        if (f.b[0] == '-')
+        {
+            // Subtract
+            if (ImStristr(text, text_end, f.b + 1, f.e) != NULL)
+                return false;
+        }
+        else
+        {
+            // Grep
+            if (ImStristr(text, text_end, f.b, f.e) != NULL)
+                return true;
+        }
+    }
+
+    // Implicit * grep
+    if (CountGrep == 0)
+        return true;
+
+    return false;
 }
 
 //-----------------------------------------------------------------------------
-// ImGuiTextBuffer
+// [SECTION] ImGuiTextBuffer
 //-----------------------------------------------------------------------------
 
